PivotTable offers the ability to set conditional rules to specific dimensions. No matter how the PivotTable layout changes, the conditional rules are only applied the specified dimensions.
Add a conditionalRule with the setConditionalRule API
Get a conditionalRule with the getConditionalRulee API
Remove a conditionalRule with the removeConditionalRule API
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
autoGenerateColumns = false;
autoMergeMode = GC.Spread.Sheets.AutoMerge.AutoMergeMode.restricted;
autoMergeSelectionMode = GC.Spread.Sheets.AutoMerge.SelectionMode.merged;
dataSource: any[];
spread: GC.Spread.Sheets.Workbook;
pivotTable: any;
scaleRule: any;
refs: string[];
refsCount: number;
currentIndex: number;
hostStyle = {
width: 'calc(100% - 300px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
this.scaleRule = new GC.Spread.Sheets.ConditionalFormatting.ScaleRule(11, 1 , 0, "#82bc00", 0 , 40000, "#f7ea00", 2 , 100000, "#e45d5d");
this.refs = ['Alan', "Bob", "John", "Serena", "Tess"];
this.refsCount = this.refs.length;
this.currentIndex = 0;
}
initSpread($Event: any) {
let spread = $Event.spread;
this.spread = spread;
spread.suspendPaint();
spread.setSheetCount(2);
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = this.getDataSource(sheet2, pivotSales);
let pivotTable = this.initPivotTable(sheet1, tableName, this.scaleRule);
this.pivotTable = pivotTable;
spread.resumePaint();
}
getDataSource(sheet: GC.Spread.Sheets.Workbook, tableSource: any) {
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1,4,0,2).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 117, 6);
for(let i=2;i<=117;i++)
{
sheet.setFormula(i-1,5,'=D'+i+'*E'+i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, tableSource);
return table.name();
}
initPivotTable(sheet: GC.Spread.Sheets.Workbook, tableName: any, rule: any) {
sheet.name("PivotTable");
sheet.setRowCount(1000);
let pivotTableOptions = {bandRows:true,bandColumns:true};
let pivotTable = sheet.pivotTables.add("PivotTable", tableName, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8, pivotTableOptions);
pivotTable.suspendLayout();
pivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
pivotTable.group(groupInfo);
pivotTable.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField);
pivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
let pivotArea = { dataOnly: true, references: [{fieldName: "Salesperson", items:["Alan"]}, {fieldName: "Cars"}]};
pivotTable.addConditionalRule([pivotArea], rule);
let style = new GC.Spread.Sheets.Style();
style.formatter = "$ #,##0";
pivotTable.setStyle({dataOnly: true}, style);
pivotTable.resumeLayout();
pivotTable.autoFitColumn();
return pivotTable;
}
getCurrentPivotAreas () {
return [
{
dataOnly: true,
references: [{
fieldName: "Salesperson",
items: [this.refs[this.currentIndex % this.refsCount]]
}, {
fieldName: "Cars"
}]
}
];
}
getNextPivotAreas () {
this.currentIndex++;
return this.getCurrentPivotAreas();
}
getPreviousPivotAreas () {
if (this.currentIndex === 0) {
this.currentIndex = this.refsCount * 10;
}
this.currentIndex--;
return this.getCurrentPivotAreas();
}
switchRegionUp () {
let pivotTable = this.pivotTable;
this.spread.suspendPaint();
pivotTable.suspendLayout();
pivotTable.removeConditionalRule(this.scaleRule);
pivotTable.addConditionalRule(this.getPreviousPivotAreas(), this.scaleRule);
pivotTable.resumeLayout();
this.spread.resumePaint();
}
switchRegionDown () {
let pivotTable = this.pivotTable;
this.spread.suspendPaint();
pivotTable.suspendLayout();
pivotTable.removeConditionalRule(this.scaleRule);
pivotTable.addConditionalRule(this.getNextPivotAreas(), this.scaleRule);
pivotTable.resumeLayout();
this.spread.resumePaint();
}
switchLayoutType(event: any) {
let spread = this.spread;
if (spread) {
let type = parseInt(event.target.value, 10);
this.pivotTable.layoutType(type);
this.pivotTable.autoFitColumn();
}
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div id="container" class="options-container">
<div class="option-row">
<label><b>Settings:</b>
</label>
</div>
<hr>
<div class="option-row">
<label>Click the <b>MoveNext</b> or <b>MovePrev</b> buttons to apply the conditional rule to the Salesperson above or below the currently highlighted dimension.
</label>
</div>
<input type="button" value="MovePrev" class="set-option" id="switch-region-up" (click)="switchRegionUp()" />
<br />
<input type="button" value="MoveNext" class="set-option" id="switch-region-down" (click)="switchRegionDown()" />
<br />
<hr>
<div class="option-row">
<label>Change the dropdown menu below to see how changing pivot table layout affects the conditional rules.
</label>
</div>
<br />
<div class="option-row">
<select id="layoutType" (change)="switchLayoutType($event)">
<option value="0">Compact Form</option>
<option value="1" selected>Outline Form</option>
<option value="2">Tabular Form</option>
</select>
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 300px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 300px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.set-option {
display: block;
margin-top: 20px;
width: 250px;
}
#reportFilterFieldsPerColumn {
width: 28px;
}
.select-option-class{
display: block;
margin-top: 20px;
margin-bottom: 10px
}
.select-option-select{
width: 250px;
display: block;
margin-bottom: 20px;
}
.option-item{
height: 20px;
margin-bottom: 10px;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.5-master-2026-07-21-2132/'
},
// map tells the System loader where to look for things
map: {
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-pivot-addon': 'cdn:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-angular': 'cdn:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

PivotTable offers the ability to set conditional rules to specific dimensions. No matter how the PivotTable layout changes, the conditional rules are only applied the specified dimensions.
Add a conditionalRule with the setConditionalRule API
Get a conditionalRule with the getConditionalRulee API
Remove a conditionalRule with the removeConditionalRule API
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
const useState = React.useState;
let currentIndex = 0;
const scaleRule = new GC.Spread.Sheets.ConditionalFormatting.ScaleRule(11, 1, 0, "#82bc00", 0, 40000, "#f7ea00", 2, 100000, "#e45d5d");
export function AppFunc() {
const [spread, setSpread] = useState(null);
const [pivotTable, setPivotTable] = useState(null);
const names = ['Alan', "Bob", "John", "Serena", "Tess"];
const namesCount = names.length;
const getCurrentPivotAreas = (isPrev) => {
if (isPrev) {
if (currentIndex === 0) {
currentIndex = namesCount * 10;
}
currentIndex--;
} else {
currentIndex++;
}
return [
{
dataOnly: true,
references: [{
fieldName: "Salesperson",
items: [names[currentIndex % namesCount]]
}, {
fieldName: "Cars"
}]
}
];
}
const switchRegionUp = () => {
spread.suspendPaint();
pivotTable.removeConditionalRule(scaleRule);
pivotTable.addConditionalRule(getCurrentPivotAreas(true), scaleRule);
spread.resumePaint();
}
const switchRegionDown = () => {
spread.suspendPaint();
pivotTable.removeConditionalRule(scaleRule);
pivotTable.addConditionalRule(getCurrentPivotAreas(), scaleRule);
spread.resumePaint();
}
const switchLayoutType = (e) => {
if (spread) {
let type = parseInt(e.target.value, 10);
pivotTable.layoutType(type);
pivotTable.autoFitColumn();
}
}
const initSpread = (spread) => {
setSpread(spread);
spread.suspendPaint();
spread.setSheetCount(2);
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = getDataSource(sheet2, pivotSales);
let pivotTable = initPivotTable(sheet1, tableName);
setPivotTable(pivotTable);
spread.resumePaint();
}
const getDataSource = (sheet, tableSource) => {
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1, 4, 0, 2).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 117, 6);
for (let i = 2; i <= 117; i++) {
sheet.setFormula(i - 1, 5, '=D' + i + '*E' + i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, tableSource);
return table.name();
}
const initPivotTable = (sheet, tableName) => {
sheet.name("PivotTable");
sheet.setRowCount(1000);
let pivotTableOptions = { bandRows: true, bandColumns: true };
let pivotTable = sheet.pivotTables.add("PivotTable", tableName, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8, pivotTableOptions);
pivotTable.suspendLayout();
pivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
pivotTable.group(groupInfo);
pivotTable.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField);
pivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
let pivotArea = { dataOnly: true, references: [{ fieldName: "Salesperson", items: ["Alan"] }, { fieldName: "Cars" }] };
pivotTable.addConditionalRule([pivotArea], scaleRule);
let style = new GC.Spread.Sheets.Style();
style.formatter = "$ #,##0";
pivotTable.setStyle({ dataOnly: true }, style);
pivotTable.resumeLayout();
pivotTable.autoFitColumn();
return pivotTable;
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
<div id="container" class="options-container">
<div class="option-row">
<label><b>Settings:</b>
</label>
</div>
<hr />
<div class="option-row">
<label>Click the <b>MoveNext</b> or <b>MovePrev</b> buttons to apply the conditional rule to the Salesperson above or below the currently highlighted dimension.
</label>
</div>
<input type="button" value="MovePrev" className="set-option" id="switch-region-up" onClick={switchRegionUp} />
<br />
<input type="button" value="MoveNext" className="set-option" id="switch-region-down" onClick={switchRegionDown} />
<br />
<hr />
<div class="option-row">
<label>Change the dropdown menu below to see how changing pivot table layout affects the conditional rules.
</label>
</div>
<br />
<div class="option-row">
<select id="layoutType" onChange={(e) => { switchLayoutType(e) }}>
<option value="0">Compact Form</option>
<option value="1" selected>Outline Form</option>
<option value="2">Tabular Form</option>
</select>
</div>
</div>
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.scaleRule = new GC.Spread.Sheets.ConditionalFormatting.ScaleRule(11, 1, 0, "#82bc00", 0, 40000, "#f7ea00", 2, 100000, "#e45d5d");
this.names = ['Alan', "Bob", "John", "Serena", "Tess"];
this.namesCount = this.names.length;
this.currentIndex = 0;
this.switchRegionUp = this.switchRegionUp.bind(this);
this.switchRegionDown = this.switchRegionDown.bind(this);
}
getCurrentPivotAreas() {
return [
{
dataOnly: true,
references: [{
fieldName: "Salesperson",
items: [this.names[this.currentIndex % this.namesCount]]
}, {
fieldName: "Cars"
}]
}
];
}
getNextPivotAreas() {
this.currentIndex++;
return this.getCurrentPivotAreas();
}
getPreviousPivotAreas() {
if (this.currentIndex === 0) {
this.currentIndex = this.namesCount * 10;
}
this.currentIndex--;
return this.getCurrentPivotAreas();
}
switchRegionUp() {
let pivotTable = this.pivotTable;
this.spread.suspendPaint();
pivotTable.removeConditionalRule(this.scaleRule);
pivotTable.addConditionalRule(this.getPreviousPivotAreas(), this.scaleRule);
this.spread.resumePaint();
}
switchRegionDown() {
let pivotTable = this.pivotTable;
this.spread.suspendPaint();
pivotTable.removeConditionalRule(this.scaleRule);
pivotTable.addConditionalRule(this.getNextPivotAreas(), this.scaleRule);
this.spread.resumePaint();
}
switchLayoutType(e) {
let spread = this.spread;
if (spread) {
let type = parseInt(e.target.value, 10);
this.pivotTable.layoutType(type);
this.pivotTable.autoFitColumn();
}
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
<div id="container" class="options-container">
<div class="option-row">
<label><b>Settings:</b>
</label>
</div>
<hr />
<div class="option-row">
<label>Click the <b>MoveNext</b> or <b>MovePrev</b> buttons to apply the conditional rule to the Salesperson above or below the currently highlighted dimension.
</label>
</div>
<input type="button" value="MovePrev" className="set-option" id="switch-region-up" onClick={this.switchRegionUp} />
<br />
<input type="button" value="MoveNext" className="set-option" id="switch-region-down" onClick={this.switchRegionDown} />
<br />
<hr />
<div class="option-row">
<label>Change the dropdown menu below to see how changing pivot table layout affects the conditional rules.
</label>
</div>
<br />
<div class="option-row">
<select id="layoutType" onChange={(e) => { this.switchLayoutType(e) }}>
<option value="0">Compact Form</option>
<option value="1" selected>Outline Form</option>
<option value="2">Tabular Form</option>
</select>
</div>
</div>
</div>
);
}
initSpread(spread) {
this.spread = spread;
spread.suspendPaint();
spread.setSheetCount(2);
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = this.getDataSource(sheet2, pivotSales);
let pivotTable = this.initPivotTable(sheet1, tableName);
this.pivotTable = pivotTable;
spread.resumePaint();
}
getDataSource(sheet, tableSource) {
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1, 4, 0, 2).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 117, 6);
for (let i = 2; i <= 117; i++) {
sheet.setFormula(i - 1, 5, '=D' + i + '*E' + i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, tableSource);
return table.name();
}
initPivotTable(sheet, tableName) {
sheet.name("PivotTable");
sheet.setRowCount(1000);
let pivotTableOptions = { bandRows: true, bandColumns: true };
let pivotTable = sheet.pivotTables.add("PivotTable", tableName, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8, pivotTableOptions);
pivotTable.suspendLayout();
pivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
pivotTable.group(groupInfo);
pivotTable.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField);
pivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
let pivotArea = { dataOnly: true, references: [{ fieldName: "Salesperson", items: ["Alan"] }, { fieldName: "Cars" }] };
pivotTable.addConditionalRule([pivotArea], this.scaleRule);
let style = new GC.Spread.Sheets.Style();
style.formatter = "$ #,##0";
pivotTable.setStyle({ dataOnly: true }, style);
pivotTable.resumeLayout();
pivotTable.autoFitColumn();
return pivotTable;
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 300px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 300px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.set-option {
display: block;
margin-top: 20px;
width: 250px;
}
#reportFilterFieldsPerColumn {
width: 28px;
}
.select-option-class{
display: block;
margin-top: 20px;
margin-bottom: 10px
}
.select-option-select{
width: 250px;
display: block;
margin-bottom: 20px;
}
.option-item{
height: 20px;
margin-bottom: 10px;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.5-master-2026-07-21-2132/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-pivot-addon': 'cdn:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-react': 'cdn:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

PivotTable offers the ability to set conditional rules to specific dimensions. No matter how the PivotTable layout changes, the conditional rules are only applied the specified dimensions.
Add a conditionalRule with the setConditionalRule API
Get a conditionalRule with the getConditionalRulee API
Remove a conditionalRule with the removeConditionalRule API
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread"> </gc-spread-sheets>
<div id="container" class="options-container">
<div class="option-row">
<label><b>Settings:</b>
</label>
</div>
<hr>
<div class="option-row">
<label>Click the MoveNext or MovePrev buttons to apply the conditional rule to the Salesperson above or below the currently highlighted dimension.
</label>
</div>
<input type="button" value="MovePrev" class="set-option" id="switch-region-up" @click="switchRegionUp()" />
<br />
<input type="button" value="MoveNext" class="set-option" id="switch-region-down" @click="switchRegionDown()" />
<br />
<hr>
<div class="option-row">
<label>Change the dropdown menu below to see how changing pivot table layout affects the conditional rules.
</label>
</div>
<br />
<div class="option-row">
<select id="layoutType" @change="switchLayoutType($event)">
<option value="0">Compact Form</option>
<option value="1" selected>Outline Form</option>
<option value="2">Tabular Form</option>
</select>
</div>
</div>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-vue";
import { shallowRef } from "vue";
import "@mescius/spread-sheets-pivot-addon";
let spreadRef = shallowRef(null);
let pivotTableRef = shallowRef(null);
let scaleRuleRef = shallowRef(null);
let namesRef = shallowRef(null);
let currentIndexRef = shallowRef(0);
function initSpread (spread) {
spreadRef.value = spread;
scaleRuleRef.value = new GC.Spread.Sheets.ConditionalFormatting.ScaleRule(11, 1 , 0, "#82bc00", 0 , 40000, "#f7ea00", 2 , 100000, "#e45d5d");
namesRef.value = ['Alan', "Bob", "John", "Serena", "Tess"];
spread.suspendPaint();
spread.setSheetCount(2);
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = getDataSource(sheet2, pivotSales);
let pivotTable = initPivotTable(sheet1, tableName);
pivotTableRef.value = pivotTable;
spread.resumePaint();
}
function getCurrentPivotAreas () {
return [
{
dataOnly: true,
references: [{
fieldName: "Salesperson",
items: [namesRef.value[currentIndexRef.value % namesRef.value.length]]
}, {
fieldName: "Cars"
}]
}
];
}
function getNextPivotAreas () {
currentIndexRef.value++;
return getCurrentPivotAreas();
}
function getPreviousPivotAreas () {
if (currentIndexRef.value === 0) {
currentIndexRef.value = namesRef.value.length * 10;
}
currentIndexRef.value--;
return getCurrentPivotAreas();
}
function switchRegionUp () {
let pivotTable = pivotTableRef.value;
spreadRef.value.suspendPaint();
pivotTable.removeConditionalRule(scaleRuleRef.value);
pivotTable.addConditionalRule(getPreviousPivotAreas(), scaleRuleRef.value);
spreadRef.value.resumePaint();
}
function switchRegionDown () {
let pivotTable = pivotTableRef.value;
spreadRef.value.suspendPaint();
pivotTable.removeConditionalRule(scaleRuleRef.value);
pivotTable.addConditionalRule(getNextPivotAreas(), scaleRuleRef.value);
spreadRef.value.resumePaint();
}
function getDataSource (sheet, tableSource) {
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1,4,0,2).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 117, 6);
for(let i=2;i<=117;i++)
{
sheet.setFormula(i-1,5,'=D'+i+'*E'+i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, tableSource);
return table.name();
}
function initPivotTable (sheet, source) {
sheet.name("PivotTable");
sheet.setRowCount(1000);
let pivotTableOptions = {bandRows:true,bandColumns:true};
let pivotTable = sheet.pivotTables.add("PivotTable", source, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8, pivotTableOptions);
pivotTable.suspendLayout();
pivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
pivotTable.group(groupInfo);
pivotTable.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField);
pivotTable.add("total", "Totals", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
let pivotArea = { dataOnly: true, references: [{fieldName: "Salesperson", items:["Alan"]}, {fieldName: "Cars"}]};
pivotTable.addConditionalRule([pivotArea], scaleRuleRef.value);
let style = new GC.Spread.Sheets.Style();
style.formatter = "$ #,##0";
pivotTable.setStyle({dataOnly: true}, style);
pivotTable.resumeLayout();
pivotTable.autoFitColumn();
return pivotTable;
}
function switchLayoutType (e) {
let spread = spreadRef.value;
if (spread) {
let type = parseInt(e.target.value, 10);
pivotTableRef.value.layoutType(type);
pivotTableRef.value.autoFitColumn();
}
}
</script>
<style scoped>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 300px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 300px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
font-size: 14px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.set-option {
display: block;
margin-top: 20px;
width: 250px;
}
#reportFilterFieldsPerColumn {
width: 28px;
}
.select-option-class{
display: block;
margin-top: 20px;
margin-bottom: 10px
}
.select-option-select{
width: 250px;
display: block;
margin-bottom: 20px;
}
.option-item{
height: 20px;
margin-bottom: 10px;
}
#app {
height: 100%;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.5-master-2026-07-21-2132/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'cdn:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'cdn:@mescius/spread-sheets-vue/index.js',
'@mescius/spread-sheets-pivot-addon': 'cdn:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);